package org.simantics.scl.compiler.elaboration.chr.plan;

import org.simantics.scl.compiler.compilation.CompilationContext;
import org.simantics.scl.compiler.elaboration.expressions.Expression;
import org.simantics.scl.compiler.elaboration.expressions.Variable;
import org.simantics.scl.compiler.elaboration.relations.SCLRelation;
import org.simantics.scl.compiler.internal.codegen.writer.CodeWriter;

public class IterateRelationOp extends PlanOp {
    
    public SCLRelation relation;
    public Variable[] variables;
    public Expression[] expressions;
    public Expression[] typeConstraintEvidenceParameters;
    public int boundMask;
    
    public IterateRelationOp(long location, SCLRelation relation, Variable[] variables, Expression[] expressions,
            Expression[] typeConstraintEvidenceParameters, int boundMask) {
        super(location);
        this.relation = relation;
        this.variables = variables;
        this.expressions = expressions;
        this.typeConstraintEvidenceParameters = typeConstraintEvidenceParameters;
        this.boundMask = boundMask;
        
    }

    @Override
    public void toString(StringBuilder b) {
        b.append("ITERATE ").append(relation);
        for(int i=0;i<expressions.length;++i)
            if((boundMask & (1 << i)) != 0) {
                b.append(" (").append(expressions[i]).append(")");
            }
            else {
                b.append(" ").append(variables[i]);
            }
    }

    @Override
    public void generateCode(CompilationContext context, PlanContext planContext, CodeWriter w) {
        relation.generateIterate(planContext, w, location, boundMask, variables, expressions, typeConstraintEvidenceParameters);
    }   
}
