package org.simantics.scl.compiler.elaboration.expressions;


public interface ExpressionVisitor {
    void visit(EApply expression);
    void visit(EApplyType expression);
    void visit(EAsPattern expression);
    void visit(EBinary expression);
    void visit(EBind expression);
    void visit(EBlock expression);
    void visit(ECHRRuleset expression);
    void visit(ECHRRulesetConstructor expression);
    void visit(EConstant expression);
    void visit(ECoveringBranchPoint expression);
    void visit(EEnforce expression);
    void visit(EEquations expression);
    void visit(EError expression);
    void visit(EExternalConstant expression);
    void visit(EFieldAccess expression);
    void visit(EGetConstraint expression);
    void visit(EIf expression);
    void visit(EIntegerLiteral expression);
    void visit(ELambda expression);
    void visit(ELambdaType expression);
    void visit(ELet expression);
    void visit(EListComprehension expression);
    void visit(EListLiteral expression);
    void visit(ELiteral expression);
    void visit(EMatch expression);
    void visit(EPlaceholder expression);
    void visit(EPreLet expression);
    void visit(ERange expression);
    void visit(ERealLiteral expression);
    void visit(ERecord expression);
    void visit(ERuleset expression);
    void visit(ESelect expression);
    void visit(ESimpleLambda expression);
    void visit(ESimpleLet expression);
    void visit(EStringLiteral expression);
    void visit(ETransformation expression);
    void visit(ETypeAnnotation expression);
    void visit(EVar expression);
    void visit(EVariable expression);
    void visit(EViewPattern expression);
    void visit(EWhen expression);
    void visit(GuardedExpressionGroup expression);
}
